# CPE 101 experimental section - pygame Assignment 3 example code
# 2D grid world that draws a different sprite for each element type 
# includes multiple resources, which 'grow' when clicked by the mouse
# the gatherer (sub) will travel to the closest resource at the start
# use 1 and 2 to toggle between (1) closest (2) furthest and use
# (0) to reset and to start gatherer moving, click the space bar
# ZJ Wood world of sub, atlantis and seaweed Feb 2014 
# **Do not copy or distribute this code without permission**

import math
import random
import entities
import occ_grid
import A3_sol
import sys, pygame
from pygame.locals import *

# define cell size
CELL_SIZE = 32 

# define some colors to be used for drawing
GREEN = ( 8, 120,  15)
LGREEN = ( 112, 255,   175)
YELLOW = ( 255, 216, 22)
ORANGE = (255, 83, 13)
PURPLE = (64, 14,  59)
LPURPLE = (120, 26,  111)
BLUE = (16, 96,   127)
RED = ( 255, 17,   36)
WHITE = ( 255, 255,   255)

# determine cell color based on occupancy value
def determineColor(occupancy_value):
   if occupancy_value == 0:
      return BLUE
   elif occupancy_value == 1:
      return YELLOW
   elif occupancy_value == 1.5:
      return ORANGE
   elif occupancy_value == 2:
      return LPURPLE
   elif occupancy_value == 3:
      return GREEN
   elif occupancy_value == 3.1:
      return LGREEN
   elif occupancy_value == 4:
      return WHITE
   else:
      return RED

# draw the 2D grid
def draw(screen, grid, cell_size, background, tile_width, tile_height):
   for y in range(0, grid.height):
      for x in range(0, grid.width):
         color = determineColor(grid.cells[y][x])
         img = background[y][x]
         screen.blit(img, ( x* tile_width, y*tile_height))         
         if grid.cells[y][x] == 0:
            screen.blit(img, ( x* tile_width, y*tile_height))         
         elif grid.cells[y][x] == 1:
            screen.blit(ship_img, ( x* tile_width, y*tile_height))         
         elif grid.cells[y][x] == 1.5:
            tempS = pygame.Surface((tile_width, tile_height))
            tempS.set_colorkey((255, 255, 255))
            tempS.blit(img, (0, 0,  x* tile_width, y*tile_height))         
            tempS.blit(bub_img, (0, 0,  x* tile_width, y*tile_height))         
            screen.blit(tempS, ( x* tile_width, y*tile_height))         
         elif grid.cells[y][x] == 2:
            tempS = pygame.Surface((tile_width, tile_height))
            tempS.set_colorkey((255, 255, 255))
            tempS.blit(img, (0, 0,  x* tile_width, y*tile_height))         
            tempS.blit(atl_img, (0, 0,  x* tile_width, y*tile_height))         
            screen.blit(tempS, ( x* tile_width, y*tile_height))         
         elif grid.cells[y][x] == 3:
            tempS = pygame.Surface((tile_width, tile_height))
            tempS.set_colorkey((255, 255, 255))
            tempS.blit(img, (0, 0,  x* tile_width, y*tile_height))         
            tempS.blit(seaw_img, (0, 0,  x* tile_width, y*tile_height))         
            screen.blit(tempS, ( x* tile_width, y*tile_height))         
         elif grid.cells[y][x] == 3.1:
            tempS = pygame.Surface((tile_width, tile_height))
            tempS.set_colorkey((255, 255, 255))
            tempS.blit(img, (0, 0,  x* tile_width, y*tile_height))         
            tempS.blit(kelp_img, (0, 0,  x* tile_width, y*tile_height))         
            screen.blit(tempS, ( x* tile_width, y*tile_height))         
         elif grid.cells[y][x] == 4:
            screen.blit(seaw_img, ( x* tile_width, y*tile_height))         
         else:
            screen.blit(img, ( x* tile_width, y*tile_height))         


#if the mouse is clicked in a valid cell, mark it
def mousePressed( grid, x, y):
   if (A3_sol.isValidPosition(grid, x/CELL_SIZE, y/CELL_SIZE) and
       grid.cells[y/CELL_SIZE][x/CELL_SIZE] == occ_grid.RESOURCE):
         grid.cells[y/CELL_SIZE][x/CELL_SIZE] = occ_grid.MARKED
         return 1
   return 0

#initialize the background
def create_background(num_rows, num_cols, tile_width, tile_height, sea) :
   background = []

   for row in range(0, num_rows):
      y = (num_rows - 1 - row)* tile_height
      background.append([])

      for col in range(0, num_cols):
         x = col*tile_width
         img = sea
         background[row].append(img)
   return background 

#function to start up the main drawing
# Note that A. Keen would prefer much more functional decomposition in other words
# Do not assume this example represents good coding style to all CPE 101 instructors
def main():
  
   GoGather = 0
   mode =A3_sol.CLOSE 
   Grow = 0
   pygame.init()
   screen_width = 640
   screen_height = 640
   screen = pygame.display.set_mode((screen_width, screen_height))

   sea_img = pygame.image.load('sea.bmp').convert()
   global seaw_img
   seaw_img = pygame.image.load('seaweed1.bmp').convert()
   global kelp_img
   kelp_img = pygame.image.load('kelp.bmp').convert()
   global atl_img 
   atl_img = pygame.image.load('atlantis.bmp').convert()
   global ship_img 
   ship_img = pygame.image.load('sub.bmp').convert()
   global bub_img 
   bub_img = pygame.image.load('bubbles2.bmp').convert()

   tile_width = 32
   tile_height = 32

   num_rows = screen_width//tile_width
   num_cols = screen_height// tile_height

   background = create_background(num_rows, num_cols, tile_width, tile_height, sea_img)

   grid = occ_grid.Grid(20, 20, occ_grid.EMPTY)
   Rlocal = 0
   s1, a1, resources = A3_sol.createEntities(grid)
   #make a copy of the sub's original position
   startSub = entities.Pos(s1.position.x, s1.position.y) 
   A3_sol.placeEntities(grid, s1, a1, resources)

   while 1:
      for event in pygame.event.get():
         if event.type == QUIT: sys.exit()
         elif event.type == pygame.KEYDOWN:
            if event.key == pygame.K_0:
               GoGather = 0
               A3_sol.resetGrid(grid, startSub,s1, a1, resources)
            if event.key == pygame.K_1:
               mode = A3_sol.CLOSE
            if event.key == pygame.K_2:
               mode = A3_sol.FAR
               print('mode ' + repr(mode))
            if event.key == pygame.K_SPACE:
               GoGather = 1
               if mode == A3_sol.CLOSE:
                  target = A3_sol.determineTarget(s1, resources, A3_sol.CLOSE)
               else:
                  target = A3_sol.determineTarget(s1, resources, A3_sol.FAR)
         elif event.type == MOUSEBUTTONUP:
            Grow = mousePressed(grid, event.pos[0], event.pos[1]) 

      draw(screen, grid, CELL_SIZE, background, tile_width, tile_height)
      pygame.display.flip()
      
      if GoGather == 1:
         A3_sol.updateEntities(grid, s1, a1, target)
      if Grow == 1:
         Rlocal = A3_sol.updateResources(grid, resources,Rlocal)
         if Rlocal > 1.9 :
            Grow = 0
      if Grow == 0:
         Rlocal = 0

if __name__ == '__main__':
   main()
